<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item :label="t('MoldManagement.MoldBrand.code')" prop="code">
        <el-input
          v-model="formData.code"
          :placeholder="t('MoldManagement.MoldBrand.placeholderCode')"
          :disabled="formType == 'update'"
        />
      </el-form-item>
      <el-form-item :label="t('MoldManagement.MoldBrand.name')" prop="name">
        <el-input
          v-model="formData.name"
          :placeholder="t('MoldManagement.MoldBrand.placeholderName')"
        />
      </el-form-item>
      <el-form-item :label="t('MoldManagement.MoldBrand.moldType')" prop="moldType">
        <el-input
          v-model="formData.moldType"
          :placeholder="t('MoldManagement.MoldBrand.placeholderMoldType')"
        />
      </el-form-item>
      <el-form-item prop="orgType">
        <template #label>
          <span>
            {{ t('MoldManagement.MoldBrand.orgType') }}
            <el-tooltip :content="t('MoldManagement.MoldBrand.orgTypeTooltip')" placement="top">
              <Icon icon="ep:question-filled" />
            </el-tooltip>
          </span>
        </template>
        <el-select
          v-model="formData.orgType"
          :placeholder="t('MoldManagement.MoldBrand.placeholderOrgType')"
        >
          <el-option
            v-for="dict in getStrDictOptions(DICT_TYPE.MES_ORG_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>

      <el-form-item :label="t('MoldManagement.MoldBrand.moldSize')" prop="moldSize">
        <el-input
          v-model="formData.moldSize"
          :placeholder="t('MoldManagement.MoldBrand.placeholderMoldSize')"
        />
      </el-form-item>
      <el-form-item :label="t('MoldManagement.MoldBrand.useTime')" prop="useTime">
        <el-input-number
          v-model="formData.useTime"
          :min="0"
          class="!w-1/1"
          :placeholder="t('MoldManagement.MoldBrand.placeholderUseTime')"
        />
      </el-form-item>
      <!-- <el-form-item label="维保模式" prop="maintainType">
        <el-select v-model="formData.maintainType" placeholder="请选择维保模式">
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.ERP_MAINTAIN_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="维保周期" prop="maintainTime">
        <el-input-number
          v-model="formData.maintainTime"
          :min="0"
          :precision="2"
          class="!w-1/1"
          placeholder="输入维保周期"
        />
      </el-form-item> -->

      <el-form-item :label="t('MoldManagement.MoldBrand.remark')" prop="remark">
        <el-input
          v-model="formData.remark"
          :placeholder="t('MoldManagement.MoldBrand.placeholderRemark')"
          type="textarea"
        />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">
        {{ t('action.save') }}
      </el-button>
      <el-button @click="dialogVisible = false">{{ t('dialog.close') }}</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getIntDictOptions, DICT_TYPE, getStrDictOptions } from '@/utils/dict'
import { MoldBrandApi, MoldBrandVO } from '@/api/erp/mold'
import { ProductApi, ProductVO } from '@/api/erp/product/product'
/** 模具型号 表单 */
defineOptions({ name: 'MoldBrandForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗
const productList = ref<ProductVO[]>([]) // 产品列表
const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  code: undefined,
  name: undefined,
  moldType: undefined,
  productId: undefined,
  useTime: undefined,
  maintainType: undefined,
  maintainTime: undefined,
  moldSize: undefined,
  remark: undefined,
  isEnable: undefined
})
const formRules = reactive({
  code: [
    { required: true, message: t('MoldManagement.MoldBrand.validatorCodeRequired'), trigger: 'blur' }
  ],
  name: [
    { required: true, message: t('MoldManagement.MoldBrand.validatorNameRequired'), trigger: 'blur' }
  ],
  moldType: [
    { required: true, message: t('MoldManagement.MoldBrand.validatorMoldTypeRequired'), trigger: 'blur' }
  ],
  productId: [
    { required: true, message: t('MoldManagement.MoldBrand.validatorProductRequired'), trigger: 'blur' }
  ],
  moldSize: [
    { required: true, message: t('MoldManagement.MoldBrand.validatorMoldSizeRequired'), trigger: 'blur' }
  ]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await MoldBrandApi.getMoldBrand(id)
    } finally {
      formLoading.value = false
    }
  }
  // 加载产品、
  productList.value = await ProductApi.getMesProductSimpleList()
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    formData.value.isEnable = true
    const data = formData.value as unknown as MoldBrandVO
    if (formType.value === 'create') {
      await MoldBrandApi.createMoldBrand(data)
      message.success(t('common.createSuccess'))
    } else {
      await MoldBrandApi.updateMoldBrand(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    code: undefined,
    name: undefined,
    moldType: undefined,
    productId: undefined,
    useTime: undefined,
    maintainType: undefined,
    maintainTime: undefined,
    moldSize: undefined,
    remark: undefined,
    isEnable: undefined
  }
  formRef.value?.resetFields()
}

</script>
